.586
.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include masm32.inc
   include BmpBut.asm
   include sqlite3.inc
   
   includelib user32.lib
   includelib kernel32.lib
   includelib gdi32.lib
   includelib masm32.lib
   includelib sqlite3.lib


WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
edit_proc proto :DWORD,:DWORD,:DWORD,:DWORD
CallBack proto :DWORD,:DWORD,:DWORD,:DWORD
DoOpenProfile proto
DoLoadBut proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
DoLoad proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
Search4Skins proto :DWORD

      CADD       MACRO quoted_text  
        LOCAL vname,lbl
          jmp lbl
            vname db quoted_text,0
          lbl:
        EXITM <ADDR vname>
      ENDM 

      FUNC       MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

      LOWORD     MACRO bigword
        mov  eax,bigword
        and  eax,0FFFFh     ;; Set to low word
      ENDM

      HIWORD     MACRO bigword
        mov eax,bigword
        shr eax,16
      ENDM

      return     MACRO arg
        mov eax, arg
        ret
	  ENDM
.data
	ClassName db "MainWinClass",0
	AppName   db "Main Window",0
	DBName    db "moby_dic.db",0
	comm1     db "INSERT INTO moby_dic (phrase,trans,examp,asoc) VALUES(",22h,0
	comm2     db 22h,");",0        ;--> "")",0
	comm3     db 22h,",",22h,0     ;--> "","",0
	comm_1    db "SELECT phrase,trans,examp,asoc FROM moby_dic WHERE phrase=='",0
	comm_2    db "'",0
	hmem1 dd 0
	hmem2 dd 0
	hmem3 dd 0
	hmem4 dd 0
	hmem5 dd 0
	hmem6 dd 0
	hmem7 dd 0
	edit1 dd 0
	edit2 dd 0
	edit3 dd 0
	edit4 dd 0
	edit5 dd 0
	brush dd 0
	show  dd 0
	menu1 dd 0
	datab dd 0
	lib   dd 0
	but   dd 0
	OldWndProc dd 0
	hold dd 0
	LF  LOGFONT    <16,10,0,0,400,0,0,0,BALTIC_CHARSET,0,0,0,0,"Courier New">
	fon dd 0
	skin byte 128 dup (0)
.data?
   hInstance HINSTANCE ?
   CommandLine LPSTR ?

.code


; ---------------------------------------------------------------------------


start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, 0
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,0
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_POPUP+WS_SYSMENU,100,\
           100,400,400,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL rrgn:DWORD
	LOCAL path[512]:BYTE
	LOCAL buf[2048]:BYTE
	LOCAL str1[512]:BYTE
	LOCAL str2[512]:BYTE
	LOCAL str3[512]:BYTE
	LOCAL str4[512]:BYTE
	LOCAL ps:PAINTSTRUCT
	LOCAL dc:DWORD
	LOCAL mpt:POINT
	LOCAL errMsg:DWORD

	.IF uMsg==WM_DESTROY
		invoke sqlite3_close,datab
		invoke DeleteDC,hmem1
		invoke DeleteDC,hmem2
		invoke DeleteDC,hmem3
		invoke DeleteDC,hmem4
		invoke DeleteDC,hmem5
		invoke DeleteDC,hmem6
		;invoke DeleteDC,hmem7
		invoke DeleteObject,fon
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_COMMAND
		LOWORD wParam
		.if eax==100
			invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_MINIMIZE,0
		.elseif eax==101
			invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,0
		.elseif eax==2000
			invoke GetWindowText,edit1,ADDR str1,512
			invoke lstrcmp,ADDR str1,CADD(0)
			je @F
			invoke GetWindowText,edit2,ADDR str2,512
			invoke lstrcmp,ADDR str2,CADD(0)
			je @F
			invoke GetWindowText,edit3,ADDR str3,512
			invoke GetWindowText,edit4,ADDR str4,512
			invoke lstrcpy,ADDR buf,ADDR comm1
			invoke lstrcat,ADDR buf,ADDR str1
			invoke lstrcat,ADDR buf,ADDR comm3
			invoke lstrcat,ADDR buf,ADDR str2
			invoke lstrcat,ADDR buf,ADDR comm3
			invoke lstrcat,ADDR buf,ADDR str3
			invoke lstrcat,ADDR buf,ADDR comm3
			invoke lstrcat,ADDR buf,ADDR str4
			invoke lstrcat,ADDR buf,ADDR comm2
			invoke MessageBox,hWnd,ADDR buf,CADD("Cool!"),MB_OK
			invoke sqlite3_exec,datab,ADDR buf,ADDR CallBack,0,ADDR errMsg
			.if eax==SQLITE_OK
				invoke MessageBox,hWnd,CADD("Yeah baby!"),CADD("Cool!"),MB_OK
				invoke SendMessage,edit1,WM_CLEAR,0,0
				invoke SendMessage,edit2,WM_CLEAR,0,0
				invoke SendMessage,edit3,WM_CLEAR,0,0
				invoke SendMessage,edit4,WM_CLEAR,0,0
			.else
				invoke MessageBox,hWnd,errMsg,CADD("Error!.."),MB_OK
			.endif
@@:			
		.endif	
	.ELSEIF uMsg==WM_CREATE
		invoke DoOpenProfile	
		invoke GetAppPath,ADDR path
		invoke lstrcat,ADDR path,CADD("skins\")
		invoke lstrcat,ADDR path,ADDR skin
		mov    hmem1,FUNC(DoLoad,hWnd,ADDR path,CADD("\left_bor.bmp"),20,400)
		mov    hmem2,FUNC(DoLoad,hWnd,ADDR path,CADD("\right_bor.bmp"),20,400)
		mov    hmem3,FUNC(DoLoad,hWnd,ADDR path,CADD("\bottom_bor.bmp"),360,20)
		mov    hmem4,FUNC(DoLoad,hWnd,ADDR path,CADD("\caption.bmp"),360,20)
		mov    hmem5,FUNC(DoLoad,hWnd,ADDR path,CADD("\search_bor_l.bmp"),20,20)
		mov    hmem6,FUNC(DoLoad,hWnd,ADDR path,CADD("\search_bor_r.bmp"),20,20)
		
		invoke DoLoadBut,hWnd,344,4,ADDR path,CADD("\min_up.bmp"),CADD("\min_ov.bmp"),CADD("\min_down.bmp"),100
		invoke DoLoadBut,hWnd,360,4,ADDR path,CADD("\close_up.bmp"),CADD("\close_ov.bmp"),CADD("\close_down.bmp"),101
		mov    edit1,FUNC(CreateWindowEx,0,CADD("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,40,140,20,hWnd,0,hInstance,0)
		mov    edit2,FUNC(CreateWindowEx,0,CADD("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,70,140,20,hWnd,0,hInstance,0)
		mov    edit3,FUNC(CreateWindowEx,0,CADD("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,100,140,20,hWnd,0,hInstance,0)
		mov    edit4,FUNC(CreateWindowEx,0,CADD("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,130,140,20,hWnd,0,hInstance,0)
		mov    edit5,FUNC(CreateWindowEx,0,CADD("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,160,100,20,hWnd,0,hInstance,0)
		mov    OldWndProc,FUNC(SetWindowLong,edit5,GWL_WNDPROC,ADDR edit_proc)
		mov    but,FUNC(CreateWindowEx,0,CADD("BUTTON"),CADD("Enter"),WS_VISIBLE+WS_CHILD,200,40,60,20,hWnd,2000,hInstance,0)
		mov    fon,FUNC(CreateFontIndirect,ADDR LF)
		invoke SendMessage,edit1,WM_SETFONT,fon,1
		invoke SendMessage,edit2,WM_SETFONT,fon,1
		invoke SendMessage,edit3,WM_SETFONT,fon,1
		invoke SendMessage,edit4,WM_SETFONT,fon,1
		invoke SendMessage,edit5,WM_SETFONT,fon,1
		invoke SendMessage,but,WM_SETFONT,fon,1
		invoke SendMessage,edit1,WM_SETTEXT,0,CADD("Dark_Metal")		
		;-------------------------------------------------------
		invoke sqlite3_open,ADDR DBName,ADDR datab
		.if eax==SQLITE_OK
			invoke MessageBox,hWnd,CADD("DB created/opened successfully!"),CADD("Cool!"),MB_OK
		.endif
		invoke sqlite3_exec,datab,CADD("CREATE TABLE moby_dic ( phrase TEXT PRIMARY KEY, trans TEXT, examp TEXT, asoc TEXT);"),ADDR CallBack,0,ADDR errMsg
		.if eax==SQLITE_OK
			invoke MessageBox,hWnd,CADD("Table(s) inserted!"),CADD("Cool!"),MB_OK
		.else
			invoke MessageBox,hWnd,errMsg,CADD("Error!.."),MB_OK
		.endif

	.ELSEIF uMsg==WM_LBUTTONDOWN
		HIWORD lParam
		.if eax <= 20
			invoke SendMessage,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam
		.endif
	.ELSEIF uMsg==WM_RBUTTONDOWN
		LOWORD lParam
		mov    mpt.x,eax
		HIWORD lParam
		mov    mpt.y,eax
		invoke ClientToScreen,hWnd,ADDR mpt
		invoke TrackPopupMenuEx,menu1,TPM_LEFTALIGN,mpt.x,mpt.y,hWnd,0

	.ELSEIF uMsg==WM_ERASEBKGND	
		return 1
	.ELSEIF uMsg==WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		invoke SetBkColor,   ps.hdc,0
		invoke ExtTextOut,   ps.hdc,0,0,ETO_OPAQUE,ADDR ps.rcPaint,0,0,0
		invoke BitBlt,ps.hdc,0,0,20,400,hmem1,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,380,0,20,400,hmem2,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,380,360,20,hmem3,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,0,360,20,hmem4,0,0,SRCCOPY
		;-------------------------------------------------
		invoke BitBlt,ps.hdc,20,40,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,180,40,20,20,hmem6,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,70,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,180,70,20,20,hmem6,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,100,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,180,100,20,20,hmem6,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,130,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,180,130,20,20,hmem6,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,160,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,140,160,20,20,hmem6,0,0,SRCCOPY		
		
		invoke EndPaint,hWnd,ADDR ps	
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp

edit_proc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL search_buf[128]:BYTE
	LOCAL buf[512]:BYTE
	LOCAL errMsg:DWORD
	.if uMsg==WM_CHAR
		invoke CallWindowProc,OldWndProc,hWnd,uMsg,wParam,lParam
		invoke GetWindowText,hWnd,ADDR search_buf,128
		invoke lstrcpy,ADDR buf,ADDR comm_1
		invoke lstrcat,ADDR buf,ADDR search_buf
		invoke lstrcat,ADDR buf,ADDR comm_2
		invoke sqlite3_exec,datab,ADDR buf,ADDR CallBack,0,ADDR errMsg
		.if eax==SQLITE_ERROR
			invoke MessageBox,hWnd,errMsg,CADD("Error!.."),MB_OK
		.endif
		return 0
	.endif
	invoke CallWindowProc,OldWndProc,hWnd,uMsg,wParam,lParam
	ret

edit_proc endp

CallBack proc not_used:DWORD,argc:DWORD,argv:DWORD,azColName:DWORD
	LOCAL count:DWORD
	
	mov   count,0
@@:	
	mov   eax,argv
	mov   ebx,count
	shl   ebx,2
	add   eax,ebx
	mov   eax,[eax]
	invoke MessageBox,0,eax,0,MB_OK
	mov   eax,argc
	inc   count
	cmp   count,eax
	jne @B
	return 0

CallBack endp

Search4Skins proc path:DWORD
	
	LOCAL _path[512]:BYTE
	;LOCAL x_pt[512]:BYTE
	LOCAL F_D:WIN32_FIND_DATA
	LOCAL find_h:DWORD
	LOCAL ic_ID:DWORD
	LOCAL ID:DWORD
	
	invoke lstrcpy,ADDR _path,path
	invoke lstrcat,ADDR _path,CADD("\*.*")
	mov    ID,1000
	invoke FindFirstFile,ADDR _path,ADDR F_D
	mov    find_h,eax
	xor    ecx,ecx
	cmp    eax,INVALID_HANDLE_VALUE
	je     exit
@@:	
    invoke lstrcmp,ADDR F_D.cFileName,CADD(".")
    cmp eax,0
    je  next
    invoke lstrcmp,ADDR F_D.cFileName,CADD("..")
    cmp eax,0
    je  next
	.if F_D.dwFileAttributes==FILE_ATTRIBUTE_DIRECTORY
		invoke AppendMenu,menu1,MF_UNCHECKED,ID,ADDR F_D.cFileName
		inc ID
	.endif
next:
    invoke FindNextFile,find_h,ADDR F_D
    or     eax,eax
    jnz    @B 
	invoke FindClose,find_h
exit: 
	xor    eax,eax    
	ret

Search4Skins endp

DoLoadBut PROC hw:DWORD,x:DWORD,y:DWORD,path:DWORD,path1:DWORD,path2:DWORD,path3:DWORD,ID:DWORD
	LOCAL _path1[512]:BYTE
	LOCAL _path2[512]:BYTE
	LOCAL _path3[512]:BYTE
	
	invoke lstrcpy,ADDR _path1,path
	invoke lstrcpy,ADDR _path2,path
	invoke lstrcpy,ADDR _path3,path
	invoke lstrcat,ADDR _path1,path1
	invoke lstrcat,ADDR _path2,path2
	invoke lstrcat,ADDR _path3,path3
	invoke BmpBut,hw,x,y,ADDR _path1,ADDR _path2,ADDR _path3,ID
	ret
DoLoadBut ENDP

DoLoad PROC hw:DWORD,path:DWORD,detail:DWORD,x:DWORD,y:DWORD
	LOCAL _path[512]:BYTE
	LOCAL dc:DWORD
	LOCAL _hmem:DWORD
	LOCAL bmp:DWORD
	LOCAL hbit:DWORD
	invoke lstrcpy,ADDR _path,path
	invoke lstrcat,ADDR _path,detail

	mov    dc,  FUNC(GetDC,hw)
	mov    _hmem,FUNC(CreateCompatibleDC,dc)
	mov    hbit,FUNC(CreateCompatibleBitmap,dc,x,y)
	mov    hold,FUNC(SelectObject,_hmem,eax)
	mov     bmp,FUNC(LoadImage,0,ADDR _path,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR+LR_LOADFROMFILE)
	mov    hold,FUNC(SelectObject,_hmem,bmp) 
	invoke ReleaseDC,hw,dc
	invoke DeleteObject,hbit
	invoke DeleteObject,bmp
	mov    eax,_hmem
	ret
DoLoad ENDP

DoOpenProfile PROC
	LOCAL path[512]:BYTE
	
	invoke GetAppPath,ADDR path
	invoke lstrcat,ADDR path,CADD("moby_dic.ini")
	
	invoke GetPrivateProfileString,CADD("EDITOR"),CADD("font_face"),CADD("default"),ADDR skin,128,ADDR path
	xor eax,eax
	ret
DoOpenProfile ENDP

end start
